<?php
/**
 * Borrow Manager
 *
 * Handles lending of disks
 *
 * @package videoDB
 * @author  Andreas Gohr <a.gohr@web.de>
 * @version $Id: borrow.php,v 2.10 2005/02/11 09:53:30 andig2 Exp $
 */

require_once './core/functions.php';

// check for localnet
localnet_or_die();

// permission check
permission_or_die(AUTH_WRITE); 
$wall = check_permission(AUTH_WRITEALL);

// borrowmanagement for single disk
$editable = false;
if (!empty($diskid))
{
	if ($wall || (get_owner($diskid,true) == $_COOKIE['VDBusername']))
	{
		$editable = true;
		if ($return) {
            $DELETE = "DELETE FROM ".TBL_LENT." WHERE diskid = '".addslashes($diskid)."'";
			runSQL($DELETE);
		}
		if (!empty($who)) {
			$who = addslashes($who);
            $INSERT = "INSERT INTO ".TBL_LENT." SET who = '".addslashes($who)."', diskid = '".addslashes($diskid)."'";
			runSQL($INSERT);
		}

		$SELECT = "SELECT who, DATE_FORMAT(dt,'%d.%m.%Y') AS dt 
                     FROM ".TBL_LENT." 
                    WHERE diskid = '".addslashes($diskid)."'";
		$result = runSQL($SELECT);
		
		$who = $result[0]['who'];
		$dt  = $result[0]['dt'];
	}
}

// overview on lent disks
$SELECT = "SELECT who, DATE_FORMAT(dt,'%d.%m.%Y') as dt, A.diskid,
                  B.title, B.id, COUNT(A.diskid) AS count, Busers.name AS owner
             FROM ".TBL_LENT.' A, '.TBL_DATA.' B
        LEFT JOIN '.TBL_USERS.' Busers ON B.owner_id = Busers.id
            WHERE A.diskid = B.diskid
         GROUP BY A.diskid
         ORDER BY who, A.diskid';
$result = runSQL($SELECT);

// check permissions
for($i=0; $i < count($result); $i++)
{
	if ($wall) {
		$result[$i]['editable'] = true;
	} elseif ($result[$i]['owner'] == $_COOKIE['VDBusername']) {
		$result[$i]['editable'] = true;
	} else {
		$result[$i]['editable'] = false;
	}
}

// prepare templates
tpl_page();

$smarty->assign('diskid', $diskid);
$smarty->assign('who', $who);
$smarty->assign('dt',  $dt);
$smarty->assign('editable',   $editable);
$smarty->assign('borrowlist', $result);

// display templates
tpl_display('borrow.tpl');

?>
