<?php
/**
 * Add a DVD/Video to VideoDB via the barcode on the box
 * Top Frame
 * (c) 2005 GPL'd
 *
 * @package Contrib
 * @author  Chinamann <chinamann@users.sourceforge.net>
 * 
 */
chdir('..');
require_once './core/functions.php';
require_once './core/genres.php';
require_once './core/custom.php';
require_once './core/security.php'; 
 
// check for localnet
localnet_or_die(); 

// multiuser permission check
$required_permisson = (empty($id) || (get_owner($id) == $_COOKIE['VDBusername'])) ? AUTH_WRITE : AUTH_WRITEALL;
permission_or_die($required_permisson);

	// fetch Media-Types from DB
    $SELECT = 'SELECT id, name
               FROM '.TBL_MEDIATYPES.'
           ORDER BY name';
    $result = runSQL($SELECT);
    foreach($result as $row)
    {
        $mediatypes[$row['id']] = $row['name'];
    }
    
	$notFound = -1;
	if (isset($_GET['barcode']) && $_GET['barcode'] != "")
	{
		// Base URL for the search
		$url = 'http://www.dvd-palace.de/dvddatabase/dbsearch.php';
		
		// Add our post options and get the data
		$url .= '?action=1&suchbegriff='.urlencode($_GET['barcode']);
		$dvdpalace_data =  httpClient  ($url, 0);
		$dvdpalace_data['data'] = preg_replace('/[\r\n\t]/',' ', $dvdpalace_data['data']);
		
		// If it succeeds....
		if ($dvdpalace_data['success'] == 1)
		{
			if (!preg_match("/Gefundene Datens&auml;tze: <b>(.*?)<\/b>/", $dvdpalace_data['data'], $matches))
			{
				if (!preg_match("/<TITLE>.*?\+\+\+(.*?)\+\+\+.*<\/TITLE>/i", $dvdpalace_data['data'], $matches)) {
					$notFound = 1;
				} else {
					$media_type = 1; //DVD
					$title = urlencode(trim($matches[1]));
					if (preg_match("/dvdid=([0-9]+)/", $dvdpalace_data['data'], $matches))
					{
						$imdbID = "DP".$matches[1];
						$url = "../edit.php?save=1&lookup=1&title=$title&diskid={$_GET['barcode']}&mediatype=$bcMediatypeId&imdbID=$imdbID";
						$specialJsCode = "parent.mainFrame.location.href='$url';";
						//$specialJsCode .= "parent.mainFrame.reload();";
						$notFound = 0;
					}
					else {
						$notFound = 3;
					} 
				}
			}
			else $notFound = 2;
		}
		else
		{
			// Print the error message
			print "Download fehlgeschlagen:<br>\n";
			print $dvdpalace_data['error'];
		}
	}
?>



<html>
<head>
    <title>DVD-Palace barcode Frame</title>
    <link rel="stylesheet" href="../<?= $config['style'] ?>" type="text/css" />
</head>
<body class="tablemenu" >
	<form name="addbarcode" method="get" action="<?=$_SERVER['PHP_SELF']?>">
		<span class="logo" style="font-size:16px;font-style:normal;float:left;">Barcode:</span>
		<?php 
			if ($notFound > 0) $textFieldStyle='style="background-color:red;"';
			elseif ($notFound == 0) $textFieldStyle='style="background-color:green;"';
		?>
		<input type="text" <?= $textFieldStyle ?> name="barcode" size="20" value="<?= $barcode ?>">
		<select name="bcMediatypeId">
		<?php 
			// set default to DVD
			if (empty($bcMediatypeId)) $bcMediatypeId = $config['mediadefault'];
			
			foreach(array_keys($mediatypes) as $mediatypeId)
   			{
   				if ($mediatypeId == $bcMediatypeId) $selected = ' selected="selected"'; else $selected = "";
   				print '<option'.$selected.' value="'.$mediatypeId.'">'.$mediatypes[$mediatypeId]."</option>\n";
    		}
		?>	 
		</select>
		<input type="submit" name="submit" value="Add">
		<?php
			if ($notFound == 1)
			{
				print '<span class="logo" style="font-size:16px;font-style:normal;float:left;">Sorry - Barcode not found!</span>';
				//print_r($dvdpalace_data);
			}
			elseif ($notFound == 2)
			{
				if ($matches[1] == "0") print '<span class="logo" style="font-size:16px;font-style:normal;float:left;">Sorry - Barcode not found!</span>';
				else print '<span class="logo" style="font-size:16px;font-style:normal;float:left;">No distinct match found (found '.$matches[1].' matches)!</span>';
				//print_r($dvdpalace_data);
			}
		?>
		
		
	</form>
	
	<script language="JavaScript">
	<!--
		document.addbarcode.barcode.focus();
		document.addbarcode.barcode.select();
		<?= $specialJsCode ?> 
	//-->
	</script>

</body>
</html>
