<?php
/**
 * Cleanup utility to remove unused images from cache folders
 *
 * @package Contrib
 * @author  Andreas Goetz   <cpuidle@gmx.de>
 * @modified  Constantinos Neophytou   <jaguarcy@gmail.com>
 */

// move out of contrib for includes
chdir('..');

require_once './core/functions.php';
require_once './core/setupfunctions.php';

?>

<html>

<head>
    <title>Cleanup Image Cache</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="VideoDB" />
<!--
    <link rel="stylesheet" href="../templates/modern/compact.css" type="text/css" />
-->    
</head>

<body>

<?

error_reporting(E_ALL ^ E_NOTICE);

// get list of all used images
//$SQL = "SELECT imgurl FROM videodata UNION SELECT imgurl FROM actors";
//$result = runSQL($SQL);

$coverSQL = "SELECT imgurl FROM videodata";
$actorSQL = "SELECT imgurl FROM actors";
$coverResult = runSQL($coverSQL);
$actorResult = runSQL($actorSQL);

foreach ($coverResult as $val) {
    $url = $val['imgurl'];
    if (preg_match("/\.(jpe?g|gif|png)$/i", $url, $matches)) 
    {
        // get the cache file name
		checkCacheFile($url, $matches[1], $file);
		$covers[] = $file;
		$images[] = $file;
    }
}

foreach ($actorResult as $val) {
    $url = $val['imgurl'];
    if (preg_match("/\.(jpe?g|gif|png)$/i", $url, $matches)) 
    {
        // get the cache file name
		checkCacheFile($url, $matches[1], $file);
		$actors[] = $file;
		$images[] = $file;
    }
}
/*
foreach ($result as $img)
{
    $url = $img['imgurl'];
    if (preg_match("/\.(jpe?g|gif|png)$/i", $url, $matches)) 
    {
        // get the cache file name
		checkCacheFile($url, $matches[1], $file);
		$images[] = $file;
    }
}
*/
$size   = 0;
$coverSize = 0;
$actorSize = 0;
$unused = 0;
$coverNum = 0;
$actorNum = 0;

// get list of all images currently in cache
list($total, $foo, $files) = analyzeCacheFolder('cache/img', true);

foreach ($files as $file)
{
    if (!in_array($file, $images))
    {
        $size += filesize($file);
        $unused++;
        
        if ($submit) unlink($file);
    }
	elseif (in_array($file, $covers))
	{
		$coverSize += filesize($file);
		$coverNum++;
	}
	elseif (in_array($file, $actors))
	{
		$actorSize += filesize($file);
		$actorNum++;
	}
}

echo "$coverNum out of ".count($files)." files with a size of ".round($coverSize/(1024*1024),2)."Mb are used for covers<br/>";
echo "$actorNum out of ".count($files)." files with a size of ".round($actorSize/(1024*1024),2)."Mb are used for headshots<br/>";
echo "$unused out of ".count($files)." files with a size of ".round($size/(1024*1024),2)."Mb are not used for covers or headshots<br/>";

if ($unused)
{
    if ($submit) 
    {
        echo "$unused files with a size of ".round($size/(1024*1024),2)."Mb have been deleted<br/>";
    }
?>
    <form action=<?=$PHP_SELF?>>
        <input type=submit name=submit value='Delete'/>
    </form>
<?
}
?>

</body>
</html>
