<?php
/**
 * TV Tome importer
 *
 * @package Contrib
 * @author  Andreas Gohr <agohr@web..de>
 * @version $Id: tvtome.php,v 2.12 2005/03/25 11:54:47 andig2 Exp $
 */

// move out of contrib for includes
chdir('..');

require_once './core/functions.php';
require_once './engines/engines.php';

localnet_or_die();
permission_or_die(AUTH_ADMIN);

error_reporting(E_ALL^E_NOTICE);

?>

<html>
<body>

<?
if ($save)
{
    save();
}
else
{
    printStartForm();
    if (!empty($tomeurl) && !empty($titlesql))
    {
        printEpisodes($tomeurl,$titlesql);
    }
}
?>

</body>
</html>


<?
// -------------- Functions follow -------------

function printStartForm()
{
  global $tomeurl;
  global $titlesql;
  ?>
  <form method="post">
  <table>
    <tr>
      <td>TV-Tome EpisodeGuide</td>
      <td><input type="text" name="tomeurl" value="<?=formvar($tomeurl)?>"></td>
      <td>e.g. <code>http://www.tvtome.com/Futurama/guide.html</code> (See <a href="http://www.tvtome.com" target="_blank">tvtome.com</a>)</td> 
    </tr>
    <tr>
      <td>VideoDB Titlesearch</td>
      <td><input type="text" name="titlesql" value="<?=formvar($titlesql)?>"></td>
      <td>e.g. <code>Futurama*</code> - Very simple search use * and ? as wildcards.</td>
    </tr>
    <tr>
      <td colspan="2" align="center">
        <input type="submit">
      </td>
      <td></td>
    </tr>
  </table>
  </form>
  
  <br><br><hr><br><br>
  <?
}

function printEpisodes($tomeurl,$titlesql)
{
    // show name only?
    if (!stristr($tomeurl, 'http://')) $tomeurl = 'http://www.tvtome.com/'.ucfirst($tomeurl).'/guide.html';
    
    // fetch data
    $episodes = fetchTomeInfos($tomeurl);
    $videos = getVideoIDs($titlesql);

?>
  <form method="post">
    <input type="hidden" name="save" value="1"/>
    
  <table>
  <?
    $row=0;
    foreach ($episodes as $ep)
{
  ?>
    <tr>
      <td>
        <input type="checkbox" name="form_eps[]" value="<?=$row?>">
        <?=$ep[number]?>: <?=$ep[title]?>
      </td>
      <td>
        <select name="form_id[<?=$row?>]">
        <?showSelect($videos,$ep[title])?>
        </select>
      </td>
    </tr>
    <tr>
      <td>
         <?=substr($ep[plot],0,250)?>...
      </td>
      <td>
        <input type="hidden" name="form_title[<?=$row?>]" value="<?=formvar($ep[title])?>">
        <input type="hidden" name="form_plot[<?=$row?>]" value="<?=formvar($ep[plot])?>">
        <input type="hidden" name="form_year[<?=$row?>]" value="<?=formvar($ep[year])?>">
        <input type="hidden" name="form_cast[<?=$row?>]" value="<?=formvar($ep[cast])?>">
      </td>
    </tr>
    <tr>
    <td colspan="2"><hr></td>
    </tr>
  <?
    $row++;
    }
  ?>
  </table>
    
  <center><input type="submit"></center>
  </form>
  <?
}

function similarity($string1,$string2)
{
  $string1 = preg_replace('/[^a-zA-Z ]/','',$string1);
  $string2 = preg_replace('/[^a-zA-Z ]/','',$string2);
  $string1 = strtolower($string1);
  $string2 = strtolower($string2);
  similar_text($string1,$string2,$sim);
  if (strstr($string1,$string2)) return 100;
  if (strstr($string2,$string1)) return 100;
  return number_format($sim, 0);
}

function showSelect($videos,$select)
{

  print '<option value=""></option>';
  foreach($videos as $vid){
    $thissim = 0;
    $sim = similarity($select,$vid[title]);
    if ($sim > $thissim) $thissim = $sim;
    $sim = similarity($select,$vid[subtitle]);
    if ($sim > $thissim) $thissim = $sim;
    $sim = similarity($select,$vid[filename]);
    if ($sim > $thissim) $thissim = $sim;
    
    if ($thissim >= 60 ){
      $SEL = "selected";
    }else{
      $SEL = "";
    }
    
    print '<option value="'.$vid[id].'" '.$SEL.'>';
    print $vid[title];
    print ' - ';
    print $vid[subtitle];
    print '   ('.$thissim.'%)';
    print '</option>';
  }
}

function save()
{
  global $form_eps;
  global $form_id;
  global $form_title;
  global $form_plot;
  global $form_year;
  global $form_cast;
  
  print '<h2>Updating Videoinfos...</h2>';
  
  foreach($form_eps as $ep){
    $id    = $form_id[$ep];    
    if (empty($id)) continue;
    $title = addslashes($form_title[$ep]);
    $plot  = addslashes($form_plot[$ep]);
    $year  = addslashes($form_year[$ep]);
    $cast  = addslashes($form_cast[$ep]);

    print $form_title[$ep].'... ';    
    $SQL = "UPDATE videodata
               SET plot = '$plot',
                   year = '$year',
                   actors = '$cast',
                   istv = 1
             WHERE id = $id";
    runSQL($SQL);
    print "done.<br>";
  }
  
  print '<p><a href="..">back to videodb</a></p>';
}

function getVideoIDs($title)
{
  $title = addslashes($title);
  $title = preg_replace('/\*/','%',$title);
  $title = preg_replace('/\?/','_',$title);
  $SQL = "SELECT id, title, subtitle, filename
            FROM videodata
           WHERE LOWER(title) LIKE LOWER('$title')
        ORDER BY title, subtitle";
  $result = runSQL($SQL);
  return $result;
}

function fetchTomeInfos($url)
{
  $response = httpClient($url, true);
  //get the main body
  preg_match('/<td width="589" align="center" valign="top">.*?<table width="580" border="0" cellspacing="2" cellpadding="2">(.*?)<\/table>.*?\n<center> Season:/si', $response[data], $matches);

  $body = $matches[1];
  //remove season headings
  $body = preg_replace('/<tr><td><a name=".*?"><h2>.*?<\/h2><\/a><\/td><\/tr>/si','',$body);

  //get episodes
  preg_match_all('/(<tr><td><b>.*?<a name=.*?)<tr><td><hr><\/td><\/tr>/si',$body,$matches,PREG_PATTERN_ORDER);

  $ep=0;
  $episodes=array();
  //get infos;
  foreach($matches[1] as $episode){

    preg_match_all('/<tr>(.*?)<\/tr>/si',$episode,$fields);
    
    //title and episodenumber
    preg_match('/<a name="ep(\d*?)" href=".*?">(.*?)<\/a>/',$fields[1][0],$match);
    $episodes[$ep][number]=$match[1];
    $episodes[$ep][title]=$match[2];
    
    //gueststars
    preg_match_all('/<a href="\/tvtome\/servlet\/PersonDetail\/personid.*?>(.*?)<\/a> \((.*?)\)/si',$fields[1][1],$gss,PREG_SET_ORDER);

    $cast = '';
    foreach($gss as $gs){
      $cast .= $gs[1];
      $cast .= '::';
      if(preg_match('/Voice of /',$gs[2])){
        $gs[2] = preg_replace('/Voice of /','',$gs[2]);
        $gs[2] .= ' (Voice)';
      }
      $cast .= $gs[2];
      $cast .= "\n";
    }
    $episodes[$ep][cast]=trim($cast);
    
    //plot
    $episodes[$ep][plot]=trim(strip_tags($fields[1][2]));
    
    //year
    preg_match('/<i>b<\/i>: \d{1,2}-.{3}-(\d{4})$/mi',$fields[1][3],$match);
    $episodes[$ep][year]=$match[1];
    
    //Director
    preg_match('/<i>d<\/i>:\s+<a href="\/tvtome\/servlet\/PersonDetail\/personid.*?>(.*?)<\/a>/si',$fields[1][3],$match);
    $episodes[$ep]['director']=$match[1];
    
    $ep++;
  }
  return $episodes;
}

?>

