<?php
/**
 * Image loader
 *
 * Loads an image from the net and creates a chachefile for it.
 *
 * @package videoDB
 * @author  Andreas Gohr    <a.gohr@web.de>
 * @version $Id: img.php,v 2.16 2005/02/11 09:53:30 andig2 Exp $ 
 */
 

require_once './core/functions.php';
require_once './engines/imdb.php';

/* 
 * Note:
 *
 * We don't clear overage thumbnails. Instead, 
 * the table entries will be replaced when an image is finally available
 */

// since we don't need session functionality, use this as workaround 
// for php bug #22526 session_start/popen hang 
session_write_close();

//amazon workaround for 1 pixel transparent images
function checkAmazonSmallImage($url, $ext, $file)
{
	if (preg_match('/^(.+)L(Z{7,}.+)$/', $url, $m)) 
    {
		list($width, $height, $type, $attr) = getimagesize($file);
		if ($width <= 1) 
        {
			$smallurl = $m[1].'M'.$m[2];
			if (checkCacheFile($smallurl, $ext, $smallfile) || download($smallurl, $smallfile)) {
				copy($smallfile, $file);
			}
		}
	}
}

// Get imgurl for the actor
if ($name) 
{

    // name given
#   $name = urldecode($name);   // decoding is not needed as $_REQUEST is already url-decoded
	$name = html_entity_decode($name);
	$result = imdbActor($name, $actorid);
	$url = $result[0][1];
	if (preg_match('/nohs(-[f|m])?.gif$/',$url)) {
		$url = '';
	} else {
        $INSERT="REPLACE ".TBL_ACTORS."
					 SET name='".addslashes($name)."',
						 imgurl='".addslashes($url)."'";
		if ($actorid) $INSERT .= ", actorid='".addslashes($actorid)."'";
		runSQL($INSERT);
	}
} 
else 
{

    // url given
#	$url = urldecode($url); // decoding is not needed as $_REQUEST is already url-decoded
}

// Get cached image for the given url
if (preg_match('/\.(jpe?g|gif|png)$/i', $url, $matches))
{

	// determine mime type
	switch (strtolower($matches[1]))
	{
		case 'gif':	$mime = 'image/gif';
					break;
		case 'png':	$mime = 'image/png';
					break;
		default:	$mime = 'image/jpeg';
	}

	// does the cache file exist?
	if (checkCacheFile($url, $matches[1], $file)) 
    {  
		// cache exists
		$data = $file;
		// amazon workaround for 1 pixel transparent images
		checkAmazonSmallImage($url, $matches[1], $file);
	} 
    // no, download successful?
    elseif (download($url, $file)) 
    {
		// cache created
		$data = $file;
	} 
    // no, use default image instead
    else 
    {
		// cache creation failed
		$mime = 'image/gif';
		$data = img('nocover.gif');
	}
} else {
	//no url given -> nopic
	$mime = 'image/gif';
	$data = img('nocover.gif');
}

header('Content-type: '.$mime);
readfile($data);

?>
