/**
 * Search page helper functions
 * Multi-engine radio button logic
 *
 * @package JavaScript
 * @author	Andreas Goetz	<cpuidle@gmx.de>
 * @version $Id: search.js,v 1.4 2005/03/03 19:05:18 andig2 Exp $
 */

/**
 * Select all search fields
 */
function selectAllFields()
{
	for (var i = 0; i < document.search['fields[]'].length; i++)
	{
		document.search['fields[]'].options[i].selected = true;
	}
}

/**
 * Remove enclosing quotes when doing external searches
 */
function unQuote(s)
{
	var result = s;

	if ((result.length > 2) && (result.substr(0,1) == "\"") && (result.substr(result.length-1,1) == "\""))
	{
		result = result.substr(1,result.length-2);
	}

	return result;
}

/**
 * Submit search form depending on selected engine
 */
function submitSearch()
{
	if (document.search.q.value) with (document.search)
	{
		var radio;
		for (var i=0; i<length; i++)
		{
			if ((elements[i].type == "radio") && (elements[i].checked)) {
				radio = elements[i].value;
			}
			if (radio) break;
		}

		switch (radio)
		{
			case "videodb":
				document.search.submit();
				break;

			case "imdb":
				document.searchIMDB.forvalue.value = unQuote(document.search.q.value);
				document.searchIMDB.submit();
				break;

			case "tvtome":
				document.searchTvtome.forvalue.value = unQuote(document.search.q.value);
				document.searchTvtome.submit();
				break;

			case "amazon":
			case "amazonxml":
				document.searchAmazon.forvalue.value = unQuote(document.search.q.value);
				document.searchAmazon.submit();
				break;
		}
	}
	else return false;
}

/**
 * Focus field and select contents
 */
function selectField(formfield)
{
	formfield.focus();
	formfield.select();
}
