<?php
/**
 * Login Screen
 *
 * Handles the login process
 *
 * @package Multiuser
 * @author  Mike Clark <Mike.Clark@Cinven.com>
 * @version $Id: login.php,v 2.18 2005/02/11 09:53:31 andig2 Exp $
 */
 
require_once './core/functions.php';
require_once './core/template.php';
require_once './core/session.php';


// get script folder for cookie path
$subdir = substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],'/')) . '/';


// Cookie exists but user and pass wasn't given? ->logout
if (!isset($username) && !isset($password) && 
    isset($_COOKIE['VDBusername']) && isset($_COOKIE['VDBpassword'])) 
{
	setcookie('VDBpassword', '', time()-7200, $subdir);
	setcookie('VDBusername', '', time()-7200, $subdir);
    setcookie('VDBuserid',   '', time()-7200, $subdir);
    $_SESSION['vdb'] = array();
	header('Location: login.php?error='.urlencode($lang['msg_loggedoff']));
	exit;
}

// login not yet successful
$login = false;

// Check that user entered stuff in username and password boxes
if (!empty($username) && !empty($password))
{
	// Lets check the format of username to make sure its ok
	if (!eregi ('[a-z]', $username)) 
    {
		$error = $lang['msg_invalidchar'];
	} 
    else 
    {
        $row = runSQL("SELECT passwd, id FROM ".TBL_USERS." WHERE name='$username'");

		// if the md5 of the entered password = whats in the database then
		// set all the cookies up again
		if (md5($password) == $row[0]['passwd'])
		{
			$userid = $row[0]['id'];
			$RandNumber = rand (100000000, 999999999);
			if ($permanent) {
				$validtime = time() + 60*60*24*365; //permanent cookie: 1 year
			} else {
				$validtime = null; // no time -> session only
			}
			setcookie('VDBusername', $username, $validtime, $subdir);
			setcookie('VDBpassword', $RandNumber, $validtime, $subdir);
			setcookie('VDBuserid', $userid, $validtime, $subdir);
            runSQL("UPDATE ".TBL_USERS." SET cookiecode='$RandNumber' WHERE id=$userid");
			$login = true;
		}
        else
        {
			$error = $lang['msg_loginfailed'];
		}
	}
}

if($login)
{
	if (empty($refer)) $refer = 'index.php';
	header('Location: '.$refer);  
}
else
{
    // prepare templates
    tpl_page('multiuser');

	$smarty->assign('error',$error);
	$smarty->assign('refer',$refer);

    // display templates
    tpl_display('login.tpl');
}

?>
