<?php
/**
 * Setup page
 *
 * Handles saving of the various config options.
 *
 * @package Setup
 * @author  Andreas Gohr <a.gohr@web.de>
 * @version $Id: setup.php,v 2.31 2005/03/04 08:51:37 andig2 Exp $
 */
 
require_once './core/session.php';
require_once './core/functions.php';
require_once './core/setupfunctions.php';

localnet_or_die();
permission_or_die(AUTH_ADMIN);

// save data
if ($save)
{
    $languageflags  = @join('::', $languages);
	$adultgenres    = @join('::', $adultgenres);

	// insert data
	foreach ($SETUP_GLOBAL as $opt)
	{
		$SQL = 'REPLACE INTO '.TBL_CONFIG." (opt,value) VALUES ('$opt','".addslashes($$opt)."')";
        runSQL($SQL);
    }
    
	// make sure default engine ist active
	if (!empty($enginedefault)) 
	{
		$opt	= 'engine'.$enginedefault;
		$$opt 	= 1;
	}

    foreach ($config['engines'] as $engine => $meta)
    {
        $opt    = 'engine'.$engine;
        $SQL    = 'REPLACE INTO '.TBL_CONFIG." (opt,value) VALUES ('$opt','".addslashes($$opt)."')";
        runSQL($SQL);
    }
    
    // update session variables
    update_session();
    
    // remove user-specific config options
	$user_id = $_COOKIE['VDBuserid'];
	if (!empty($user_id))
	{  
        $SQL = "DELETE FROM ".TBL_USERCONFIG." WHERE user_id = '".addslashes($user_id)."'";
        runSQL($SQL);
	}

	// reload config
	loadconfig(true);

/*
    // clear compiled templates for new template
    AG: should not be required
    $smarty->clear_compiled_tpl(null, $config['cacheid']);
*/    
} 

// check permissions again - they may have changed
if (!check_permission(AUTH_ADMIN))
{
    header('Location: login.php');
}

// destroy cookies if required
if ($_COOKIE['VDBusername'] &! $config['multiuser'])
{
    setcookie('VDBpassword', '', time()-7200);
    setcookie('VDBusername', '', time()-7200);
    setcookie('VDBuserid',   '', time()-7200);
}

// cache maintenance
list($total, $expired, $files) = analyzeCacheFolder('cache/imdb', !empty($cacheempty));

if ($total)
{
	// delete from cache directory?
	if ($cachecleanup || $cacheempty)
	{
		foreach ($files as $file) unlink($file);
		$total  -= $expired;
		$expired = 0;
	}

	$smarty->assign('total',   round($total/(1024*1024), 2));
	$smarty->assign('expired', round($expired/(1024*1024), 2));
}


// prepare options
$setup = setup_mkOptions(false);

/*
print '<pre>';
print_r($setup);
print '</pre>';
*/

// prepare templates
tpl_page('configview');

$smarty->assign('setup', $setup);

// display templates
tpl_display('setup.tpl');

?>
