<?php
/**
 * Movie Detail View
 *
 * Shows all data of a movie
 *
 * @package videoDB
 * @author  Andreas Gohr    <a.gohr@web.de>
 * @author  Andreas Goetz   <cpuidle@gmx.de>
 * @version $Id: show.php,v 2.23 2005/04/06 07:48:38 andig2 Exp $
 */

require_once './core/functions.php';
require_once './core/custom.php';

// random view
if (empty($id)) 
{
	$count = 0;
    
    // find a random id
    $SELECT = 'SELECT id, REVERSE(RAND(NOW())) AS rnd
                 FROM videodata
                WHERE mediatype != 50
             ORDER BY rnd
                LIMIT 1';

	while (!$id)
	{
		$result = runSQL($SELECT);
        
        // prevent endless loop
        if (!count($result) || ($count++ > 50)) break;
        
		$id = $result[0]['id'];
		if (!adultcheck($id)) $id = 0;  //adult movie? -> try again
	}
	// id still empty? go back to index.
	if (empty($id)) header('Location: index.php');
}

// get data (id may be empty on a empty database)
if (!empty($id))
{
	// no adult permissions? -> random
	if (!adultcheck($id)) header('Location: show.php');

    // XML export?
    if (($export == 'xml') && $config['xml'])
    {
        require_once './core/'.$export.'.php';
        xmlexport('videodata.id = '.$id);
        exit;
    }

	$SELECT = 'SELECT videodata.id, title, subtitle, language, diskid, comment,
					disklabel, imdbID, year, imgurl, director, actors, runtime,
					country, plot, filename, filesize, filedate, audio_codec,
					video_codec, video_width, video_height, istv, lastupdate,
                    seen, email, custom1, custom2, custom3, custom4, 
                    users.name AS owner, mediatypes.name AS mediatype
			   FROM videodata 
		  LEFT JOIN users ON owner_id = users.id
          LEFT JOIN mediatypes ON mediatype = mediatypes.id
			  WHERE videodata.id = '.$id;
	$video = runSQL($SELECT);

	// get seen status for currently logged in user
	$video[0]['seen'] = get_userseen($id,$video[0]['seen']);

	// is it editable?
	if ($video[0]['owner'] == $_COOKIE['VDBusername']) {
		$video[0]['editable'] = check_permission(AUTH_WRITE);
	} else {
		$video[0]['editable'] = check_permission(AUTH_WRITEALL);
	}
	$video[0]['editable'] = $video[0]['editable'] && localnet();

	// save if seen was clicked
	if ($save)
	{
		if (!$seen) $seen = 0;
		if ($video[0]['editable'])
		{
			// owner can save directly to videodata
			runSQL('UPDATE videodata SET seen = '.$seen.' WHERE id = '.$id);
		}
		set_userseen($id,$seen); // additonally save to userseen
		$video[0]['seen'] = $seen;
	}

	// diskid to global scope:
	$diskid = $video[0]['diskid'];

	// check if it is lent and to whom
	$SELECT = "SELECT who
			     FROM lent
			    WHERE diskid = '$diskid'";
	$result = runSQL($SELECT);
	if (isset($result[0]['who']))
    {
		$video[0]['who'] = $result[0]['who'];
	}
}

// prepare templates
tpl_page('detailview', $video[0]['title']);
if (!empty($id)) tpl_show($video[0]);

// display templates
$smarty->display('header.tpl');
flush();
if (!empty($id)) $smarty->display('show.tpl');
$smarty->display('footer.tpl');

?>
