<?php
/**
 * User Management
 *
 * User administration functions
 *
 * @package Multiuser
 * @author  Andreas Gohr <a.gohr@web.de>
 * @version $Id: users.php,v 1.12 2005/02/11 09:53:31 andig2 Exp $
 */

require_once './core/functions.php';
require_once './core/template.php';

localnet_or_die();
permission_or_die(AUTH_ADMIN);

/**
 * Create user
 *
 * @param string $user Username
 * @param string $pass Password
 * @param string $perm permission as integer
 * @return boolean     true on success
 */
function create_user($user,$pass,$perm,$email)
{
    $pw = md5($pass);
    $SQL = "INSERT INTO ".TBL_USERS."
               SET name = '".addslashes($user)."',
                   passwd = '$pw',
                   permissions = $perm,
                   email = '".addslashes($email)."'";
    runSQL($SQL);
    return true;
}

// calculate permissions
if ($adminflag) {
	$perm = AUTH_ADMIN + AUTH_WRITEALL + AUTH_WRITE + AUTH_ADULT;
} else {
	if ($writeallflag) {
		$perm = AUTH_WRITEALL + AUTH_WRITE;
	} elseif ($writeflag) {
		$perm = AUTH_WRITE;
	} else {
		$perm=0;
	}
	if ($adultflag) $perm += AUTH_ADULT;
}

// new user?
if (!(empty($newuser) || empty($password)))
{
	create_user($newuser, $password, $perm, $email);
	$message = $lang['msg_usercreated'];
}

// update user?
elseif (!empty($id) &! empty($name))
{
    runSQL("UPDATE ".TBL_USERS."
               SET name = '".addslashes($name)."', permissions = $perm, email = '".addslashes($email)."'
			 WHERE id = '$id'");
	// new password?
	if (!empty($password))
	{
		$pw = md5($password);
        runSQL("UPDATE ".TBL_USERS." SET passwd = '$pw' WHERE id = '$id'");
		$message = $lang['msg_permpassupd'];
	} else {
		$message = $lang['msg_permupd'];
	}
}

// delete user?
elseif (!empty($del))
{
    validate_input($del);

    runSQL('DELETE FROM '.TBL_USERS.' WHERE id = '.$del);
    runSQL('DELETE FROM '.TBL_USERCONFIG.' WHERE user_id = '.$del);
	$message = $lang['msg_userdel'];
}

// current user permissions
$result = runSQL('SELECT id, name, permissions, email
                    FROM '.TBL_USERS.'
                ORDER BY name');
foreach ($result as $user)
{
	$user['admin']		= ($user['permissions'] & AUTH_ADMIN);
	$user['writeall']	= ($user['permissions'] & AUTH_WRITEALL);
	$user['write']		= ($user['permissions'] & AUTH_WRITE);
	$user['adult']		= ($user['permissions'] & AUTH_ADULT);
	$userlist[] 		= $user;
}

// prepare templates
tpl_page('usermanager');

$smarty->assign('userlist', $userlist);
$smarty->assign('message', $message);

// display templates
tpl_display('users.tpl');

?>
